%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program do zobrazowania wynikw DPF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program przedstawia widmo impulsu prostoktnego przy rnych stosunkach
% czasu trwania impulsu do czasu obserwacji.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all;
clear;
clc;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% posta sygnau: prostoktny impuls wizyjny x(n)=1
% dla n nalecych do <0,N-1>
% ilo prbek 
N=8;
% wektor prbek czstotliwociowych
k=0:N-1;
% taki sam wektor prbek czasu
n=k;
% impuls
x=ones(1,N);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Poddanie dyskretnemu przeksztaceniu Fouriera sygnau prostoktnego tylko
% w jego niezerowej czci powoduje, e obserwujemy widmo sygnau staego.
% Uzupenienie sygnau dodatkowymi zerami powoduje, e widmo sygnau
% zaczyna odzwierciedla widmo impulsu prostoktnego.
% dodatkowe zera
ileprob=1024;
ilezer=ileprob-N;
x=[x zeros(1,ilezer)];

nrprob=(0:ileprob-1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% wyznaczamy widmo
W=fft(x);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% wykres analizowanego sygnau
fig1=figure;
fig1.WindowState='maximized';
subplot(3,1,1);
bar(nrprob,x,'b');
ylim([0 1.2]);
title('Posta czasowa impulsu prostoktnego');
xlabel('Numer prbki czasu n');
ylabel('Warto prbki x(n)');
% wykres widma amplitudowego
subplot(3,1,2);
bar(nrprob,abs(W),'b');
title(['Widmo amplitudowe impulsu prostoktnego z ' num2str(ilezer) ' dodatkowymi zerami']);
xlabel('Numer prbki czstotliwociowej k');
ylabel('Warto prbki X(k)');
% wykres widma fazowego
subplot(3,1,3);
bar(nrprob,angle(W),'b');
title(['Widmo fazowe impulsu prostoktnego z ' num2str(ilezer) ' dodatkowymi zerami']);
xlabel('Numer prbki czstotliwociowej k');
ylabel('Warto prbki X(k)');
% koniec programu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%